package org.jeecg.modules.studytourActivityDate.controller;

import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.vo.LoginUser;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.studytourActivityDate.entity.StudytourDatePrice;
import org.jeecg.modules.studytourActivityDate.entity.StudytourActivityDate;
import org.jeecg.modules.studytourActivityDate.vo.StudytourActivityDatePage;
import org.jeecg.modules.studytourActivityDate.service.IStudytourActivityDateService;
import org.jeecg.modules.studytourActivityDate.service.IStudytourDatePriceService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 团期信息表
 * @Author: jeecg-boot
 * @Date:   2025-09-08
 * @Version: V1.0
 */
@Api(tags="团期信息表")
@RestController
@RequestMapping("/studytourActivityDate/studytourActivityDate")
@Slf4j
public class StudytourActivityDateController {
	@Autowired
	private IStudytourActivityDateService studytourActivityDateService;
	@Autowired
	private IStudytourDatePriceService studytourDatePriceService;
	
	/**
	 * 分页列表查询
	 *
	 * @param studytourActivityDate
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "团期信息表-分页列表查询")
	@ApiOperation(value="团期信息表-分页列表查询", notes="团期信息表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<StudytourActivityDate>> queryPageList(StudytourActivityDate studytourActivityDate,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StudytourActivityDate> queryWrapper = QueryGenerator.initQueryWrapper(studytourActivityDate, req.getParameterMap());
		Page<StudytourActivityDate> page = new Page<StudytourActivityDate>(pageNo, pageSize);
		IPage<StudytourActivityDate> pageList = studytourActivityDateService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param studytourActivityDatePage
	 * @return
	 */
	@AutoLog(value = "团期信息表-添加")
	@ApiOperation(value="团期信息表-添加", notes="团期信息表-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StudytourActivityDatePage studytourActivityDatePage) {
		StudytourActivityDate studytourActivityDate = new StudytourActivityDate();
		BeanUtils.copyProperties(studytourActivityDatePage, studytourActivityDate);
		studytourActivityDateService.saveMain(studytourActivityDate, studytourActivityDatePage.getStudytourDatePriceList());
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param studytourActivityDatePage
	 * @return
	 */
	@AutoLog(value = "团期信息表-编辑")
	@ApiOperation(value="团期信息表-编辑", notes="团期信息表-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StudytourActivityDatePage studytourActivityDatePage) {
		StudytourActivityDate studytourActivityDate = new StudytourActivityDate();
		BeanUtils.copyProperties(studytourActivityDatePage, studytourActivityDate);
		StudytourActivityDate studytourActivityDateEntity = studytourActivityDateService.getById(studytourActivityDate.getId());
		if(studytourActivityDateEntity==null) {
			return Result.error("未找到对应数据");
		}
		studytourActivityDateService.updateMain(studytourActivityDate, studytourActivityDatePage.getStudytourDatePriceList());
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "团期信息表-通过id删除")
	@ApiOperation(value="团期信息表-通过id删除", notes="团期信息表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		studytourActivityDateService.delMain(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "团期信息表-批量删除")
	@ApiOperation(value="团期信息表-批量删除", notes="团期信息表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.studytourActivityDateService.delBatchMain(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "团期信息表-通过id查询")
	@ApiOperation(value="团期信息表-通过id查询", notes="团期信息表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<StudytourActivityDate> queryById(@RequestParam(name="id",required=true) String id) {
		StudytourActivityDate studytourActivityDate = studytourActivityDateService.getById(id);
		if(studytourActivityDate==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(studytourActivityDate);

	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "年龄段价格表通过主表ID查询")
	@ApiOperation(value="年龄段价格表主表ID查询", notes="年龄段价格表-通主表ID查询")
	@GetMapping(value = "/queryStudytourDatePriceByMainId")
	public Result<List<StudytourDatePrice>> queryStudytourDatePriceListByMainId(@RequestParam(name="id",required=true) String id) {
		List<StudytourDatePrice> studytourDatePriceList = studytourDatePriceService.selectByMainId(id);
		return Result.OK(studytourDatePriceList);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param studytourActivityDate
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StudytourActivityDate studytourActivityDate) {
      // Step.1 组装查询条件查询数据
      QueryWrapper<StudytourActivityDate> queryWrapper = QueryGenerator.initQueryWrapper(studytourActivityDate, request.getParameterMap());
      LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

      //Step.2 获取导出数据
      List<StudytourActivityDate> queryList = studytourActivityDateService.list(queryWrapper);
      // 过滤选中数据
      String selections = request.getParameter("selections");
      List<StudytourActivityDate> studytourActivityDateList = new ArrayList<StudytourActivityDate>();
      if(oConvertUtils.isEmpty(selections)) {
          studytourActivityDateList = queryList;
      }else {
          List<String> selectionList = Arrays.asList(selections.split(","));
          studytourActivityDateList = queryList.stream().filter(item -> selectionList.contains(item.getId())).collect(Collectors.toList());
      }

      // Step.3 组装pageList
      List<StudytourActivityDatePage> pageList = new ArrayList<StudytourActivityDatePage>();
      for (StudytourActivityDate main : studytourActivityDateList) {
          StudytourActivityDatePage vo = new StudytourActivityDatePage();
          BeanUtils.copyProperties(main, vo);
          List<StudytourDatePrice> studytourDatePriceList = studytourDatePriceService.selectByMainId(main.getId());
          vo.setStudytourDatePriceList(studytourDatePriceList);
          pageList.add(vo);
      }

      // Step.4 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      mv.addObject(NormalExcelConstants.FILE_NAME, "团期信息表列表");
      mv.addObject(NormalExcelConstants.CLASS, StudytourActivityDatePage.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("团期信息表数据", "导出人:"+sysUser.getRealname(), "团期信息表"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
    }

    /**
    * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<StudytourActivityDatePage> list = ExcelImportUtil.importExcel(file.getInputStream(), StudytourActivityDatePage.class, params);
              for (StudytourActivityDatePage page : list) {
                  StudytourActivityDate po = new StudytourActivityDate();
                  BeanUtils.copyProperties(page, po);
                  studytourActivityDateService.saveMain(po, page.getStudytourDatePriceList());
              }
              return Result.OK("文件导入成功！数据行数:" + list.size());
          } catch (Exception e) {
              log.error(e.getMessage(),e);
              return Result.error("文件导入失败:"+e.getMessage());
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.OK("文件导入失败！");
    }

}
